#include "common.h"
#include "dbDict.h"
#include "util.h"

static Boolean write(FileHand f,const void* s,UInt32 len){
	
	Err err;
	
	return len == FileWrite(f,s,1,len,&err) && err == errNone;
}

static Boolean read(FileHand f,void* d,UInt32 len){
	
	Err err;
	
	return len == FileRead(f,d,1,len,&err) && err == errNone;
}

Boolean dbDictRead(Dict* intoHere){
	
	FileHand f;
	Err err;
	Boolean ret = false;
	UInt16 i,L;
	char* k;
	char* v;
	
	dictEmpty(intoHere);
	
	k = malloc(MAX_STRING_LEN);
	if(k){
		
		v = malloc(MAX_STRING_LEN);
		if(v){
			
			f = FileOpen(0,DB_NAME,DB_TYPE,DB_CRID,fileModeReadOnly,&err);
			if(err == errNone && f != NULL){
				
				if(read(f,&L,2)){
					
					while(L--){
						
						i = 0;
						
						ret = true;
						
						do{	//read the key
							
							if(!read(f,k + i,1)){
								
								ret = false;
								goto out;
							}
							i++;
							
						}while(k[i - 1]);
						
						i = 0;
						
						do{	//read the value
							
							if(!read(f,v + i,1)){
								
								ret = false;
								goto out;
							}
							i++;
							
						}while(v[i - 1]);
						
						if(ret) ret = dictAdd(intoHere,k,v,NULL);
						
						if(!ret){
							
							goto out;
						}
					}
				}
out:
				FileClose(f);
			}
			free(v);
		}
		free(k);
	}
	
	if(!ret){
		
		dictEmpty(intoHere);
	}
	
	return ret;
}

Boolean dbDictWrite(Dict* fromHere){
	
	FileHand f;
	Err err;
	Boolean ret = false;
	UInt16 i,L;
	char* k;
	char* v;
	
	f = FileOpen(0,DB_NAME,DB_TYPE,DB_CRID,fileModeReadWrite,&err);
	
	if(err != errNone || f == NULL) return false;
	
	L = dictCount(fromHere);
	
	if(write(f,&L,2)){
		
		ret = true;
		
		for(i = 0; i < L; i++){
			
			dictGet(fromHere,i,&k,&v);
			
			if(!write(f,k,StrLen(k) + 1) || !write(f,v,StrLen(v) + 1)){
				
				ret = false;
				break;
			}
		}
	}
	
	FileClose(f);
	
	if(!ret){
		
		FileDelete(0,DB_NAME);
	}
	
	return ret;
}