#ifndef _DICT_H_
#define _DICT_H_

#include <PalmTypes.h>


typedef struct{
	
	UInt16	numEntries;
	char**	keys;
	char**	vals;
	
}Dict;


typedef Int16 (*DictSortFunc)(char* key1,char* val1,char* key2,char* val2);

Dict* dictNew();
void dictDestroy(Dict* dict);
void dictEmpty(Dict* d);
Boolean dictAdd(Dict* dict,char* key,char* val,UInt16* itemIdxP);
void dictSort(Dict* dict,DictSortFunc cmp);
Boolean dictGet(Dict* dict,UInt16 i,char** key,char** val);
void dictDel(Dict* dict,UInt16 i);
void dictMod(Dict* dict,UInt16 i,char* newKey,char* newVal);
UInt16 dictCount(Dict* dict);
Boolean dictLookup(Dict* dict,char* k,UInt16* idxP,char** valP);




#endif