#include "common.h"
#include "util.h"



void* malloc(UInt32 sz){
	
	return MemChunkNew(0,sz,0x1200);
}

void free(void* ptr){
	
	MemChunkFree(ptr);
}

char* strdup(const char* str){
	
	char* ret = NULL;
	
	if(str){
		
		ret = malloc(StrLen(str) + 1);
		if(ret){
			
			StrCopy(ret,str);
		}
	}
	
	return ret;
}

UInt32 swap32(UInt32 v){
	
	return ((v >> 24) & 0xFF) | ((v >> 8) & 0xFF00) | ((v & 0xFF00) << 8) | ((v & 0xFF)<< 24);
}

UInt16 swap16(UInt16 v){
	
	return (v >> 8) | (v << 8);
}

void* swapptr(void* p){
	
	return (void*)swap32((UInt32)p);
}